// Copyright (c) 2010-2018 LG Electronics, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

#ifndef OSINFORMATIONSERVICE_H
#define OSINFORMATIONSERVICE_H

#include <map>
#include <string>

#include <nyx/nyx_client.h>

#include "Singleton.h"

struct LSHandle;
struct LSMessage;

class OsInfoService : public Singleton<OsInfoService>
{
	friend class Singleton<OsInfoService>;

public:
	typedef std::map<std::string, nyx_os_info_query_t> command_map_t;

	void setServiceHandle(LSHandle* serviceHandle);

	static bool cbGetOsInformation(LSHandle* lshandle, LSMessage *message, void *user_data);

private:
	OsInfoService();

	static const command_map_t& getCommandMap();
};

#endif //OSINFORMATIONSERVICE_H
